#!/usr/bin/perl

#=============================================================================
# ubiqun_service.pl: timer executer for ubiqun.pl/ubiqun.exe (ver.20030304)
#
# Copyright (C) 2002-2003 OHKUBO Masahiko <mah@pobox.ne.jp>
# The latest version is available here: http://mah.pobox.ne.jp/ubiqun/
#=============================================================================
#
# usage: ubiqun_service.pl /¹Դֳ -ޥɥ饤󥪥ץ...
#        ubiqun_service.exe /¹Դֳ -ޥɥ饤󥪥ץ...
#
#        ¹Դֳ: ubiqun.pl/ubiqun.exe ¹Ԥֳ֡ñ̤á
#        ޥɥ饤󥪥ץ: ubiqun.pl/ubiqun.exe ѤΤ
#        ) ubiqun_service.exe /60

# ưΤ뤷
print 'ubiqun_service.pl start:' . "\n"; #<perl2exe_comment>
#print 'ubiqun_service.exe start:' . "\n"; #<perl2exe_execute>

# ͤꤷƤ
$option = '-mode=client';
$sleeptime = 300;
$sleeptime_min = 10;
$sleeptime_max = 86400;

# ubiqun.exe μ¹Դֳ֤ꤹ
if ($ARGV[0] =~ /^\/(\d+)$/) {
	$sleeptime = $1;
	shift(@ARGV);
}
if ($sleeptime > $sleeptime_max) {
	$sleeptime = $sleeptime_max;
} elsif ($sleeptime < $sleeptime_min) {
	$sleeptime = $sleeptime_min;
}

# ubiqun.pl/ubiqun.exe εưޥɤ
$command = $0;
$command =~ s/ubiqun_service\.(pl|exe)$/ubiqun\.$1/i;
$command = '"' . $command . '" ';
if ($^X =~ /(perl|perl\.exe)$/i) {
	# Perl 󥿥ץ꥿ͳʤ
	$command = '"' . $^X . '" ' . $command;
}
while (@ARGV) {
	($key, $value) = split('=', shift(@ARGV), 2);
	if ($value ne '') {
		if (($key =~ /^-dir_/) || ($key =~ /^-file_/)) {
			$value = &ESCAPE_SPACE($value);
		}
		$option .= ' ' . $key . '=' . $value;
	} else {
		$option .= ' ' . $key;
	}
}

# ubiqun.pl/ubiqun.exe ֳ֤ǵư
while (1) {
	$| = 1;
	print `$command $option` || warn('ERROR(service): cannot execute child process. / command = ' . $command . ' ' . $option);
	$| = 0;
	print 'INTERVAL: ' . $sleeptime . 'sec.' . "\n";
	sleep $sleeptime;
}



#---------------------------------------------------

# ڡ򵭹ִ (ޥɥ饤󥪥ץк)
sub ESCAPE_SPACE {
	my($line) = @_;

	$line =~ s/ /\%20/g;
	return($line);
}
